/***************************************************************************
                          awaymessagedialog.h  -  description
                             -------------------
    begin                : Sat Dec 14 2002
    copyright            : (C) 2002 by Mike K. Bennett
    email                : mkb137b@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AWAYMESSAGEDIALOG_H
#define AWAYMESSAGEDIALOG_H

#include <kdialogbase.h>

// Forward declarations
class QTextEdit;


/**The dialog lets the user set the auto-reply message.
  *@author Mike K. Bennett
  */

class AwayMessageDialog : public KDialogBase
{
   Q_OBJECT

  public:
    // The constructor
   	             AwayMessageDialog(QWidget *parent=0, const char *name=0);
    // The destructor
  	            ~AwayMessageDialog();
    // Show the dialog
    bool         useMessage(QString &message);

  protected slots: // Protected slots
    // The Cancel button was pressed.
    void         slotCancel();
    // The OK button was pressed.
    void         slotOk();

  private: // Private attributes
    // The edit box for the away message
    QTextEdit*   messageEdit_;
    // Whether or not OK was pressed.
    bool         ok_;
};

#endif
