/***************************************************************************
                          emoticonwidget.h -  description
                             -------------------
    begin                : Sun Dev 11 2005
    copyright            : (C) 2005 by Diederik van der Boor
    email                : "vdboor" --at-- "codingdomain.com"
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef EMOTICONWIDGET_H
#define EMOTICONWIDGET_H

#include "emoticonwidgetinterface.h"

class Account;

class EmoticonWidget : public EmoticonWidgetInterface
{
  Q_OBJECT

  public:  // public methods
    // The constructor
                       EmoticonWidget(QWidget* parent = 0, const char* name = 0);
    // The destructor
    virtual           ~EmoticonWidget();

    // Load the widget settings
    void               loadSettings( Account *account );
    // Save the widget settings
    void               saveSettings( Account *account );


  protected slots:
    // The install button was pressed
    virtual void       slotInstallEmoticons();


  private:  // private methods
    // Initialize the widget
    void               updateEmoticonList();


  private:  // private properties
    QString            emoticonStyle_;
};

#endif

